# NGSpy 6.2 file created by SEQUOIA Cell Designer V21.2 (Build 2021/03/22) on Monday, 26 April, 2021
import time
from ngsolve import *
from netgen.csg import *
p1 = Plane (Pnt(0,0,-0), Vec(0,0,-1) )
p2 = Plane (Pnt(0,0,1.0), Vec( 0,0,1) )
p3 = Plane (Pnt(0,-1.25,0), Vec(0,-1,0) )
p4 = Plane (Pnt(0, 0.75, 0), Vec(0, 1,0) )
p5 = Plane (Pnt(-1.3, 0, 0), Vec(-1, 0, 0) )
p6 = Plane (Pnt(1.2, 0, 0), Vec(1, 0, 0) )
  
planes = p1 * p2 * p3 * p4 * p5 * p6
#ob = planes.bc("oxide").mat("SiO2")
path = SplineCurve3d()
path.AddPoint (0,0,10)
path.AddPoint (0,0,0)
path.AddPoint (0,0,-10)
path.AddSegment (0,1,2)

spline = SplineCurve2d() 
spline.AddPoint (-1.1,-1.0)
spline.AddPoint (-1.1,-1.1)
spline.AddPoint (-1.2,-1.1)
spline.AddPoint (-1.2,-1.0)
spline.AddSegment (0,1,2)
spline.AddSegment (2,3,0)
extr = Plane (Pnt(0,0,0.2), Vec(0,0,-1) )*Plane (Pnt(0,0,0.3), Vec( 0,0,1) )*Extrusion(path,spline,Vec(0,1,0)).bc("1")

p_M1_0_1 = OrthoBrick( Pnt(-0.5,-0.71,0.05), Pnt(-0.45,-0.66,0.1) )
p_M1_0_2 = OrthoBrick( Pnt(-0.36,0.23,0.05), Pnt(-0.32,0.35,0.1) )
p_M1_0_3 = OrthoBrick( Pnt(-0.12,0.14,0.05), Pnt(-0.08,0.26,0.1) )
p_M1_0_4 = OrthoBrick( Pnt(-0.357,-0.215,0.05), Pnt(-0.313,-0.099,0.1) )
p_M1_0_5 = OrthoBrick( Pnt(-0.09,-0.3,0.05), Pnt(-0.05,-0.18,0.1) )
p_M1_0_6 = OrthoBrick( Pnt(0.71,-0.02,0.05), Pnt(0.76,0.03,0.1) )
p_M1_0_7 = OrthoBrick( Pnt(0.21,-0.72,0.05), Pnt(0.26,-0.4,0.1) )
p_M1_0_8 = OrthoBrick( Pnt(-0.72,-0.71,0.05), Pnt(-0.66,-0.54,0.1) )
p_M1_0_9 = OrthoBrick( Pnt(0.45,-0.72,0.05), Pnt(0.5,-0.67,0.1) )
p_M1_0_10 = OrthoBrick( Pnt(-1.25,-0.02,0.05), Pnt(-1.2,0.03,0.1) )
geo = CSGeometry()

geo.Add(extr , bcmod=[(extr,'111')])

geo.Add(planes - p_M1_0_1 - p_M1_0_2 - p_M1_0_3 - p_M1_0_4 - p_M1_0_5 - p_M1_0_6 - p_M1_0_7 - p_M1_0_8 - p_M1_0_9 - p_M1_0_10)
regp_M1_0_1  = planes * p_M1_0_1.mat("elec1").maxh(0.1)
geo.Add(regp_M1_0_1 , bcmod=[(regp_M1_0_1,'1')])
regp_M1_0_2  = planes * p_M1_0_2.mat("elec2").maxh(0.1)
geo.Add(regp_M1_0_2 , bcmod=[(regp_M1_0_2,'2')])
regp_M1_0_3  = planes * p_M1_0_3.mat("elec3").maxh(0.1)
geo.Add(regp_M1_0_3 , bcmod=[(regp_M1_0_3,'3')])
regp_M1_0_4  = planes * p_M1_0_4.mat("elec4").maxh(0.1)
geo.Add(regp_M1_0_4 , bcmod=[(regp_M1_0_4,'4')])
regp_M1_0_5  = planes * p_M1_0_5.mat("elec5").maxh(0.1)
geo.Add(regp_M1_0_5 , bcmod=[(regp_M1_0_5,'5')])
regp_M1_0_6  = planes * p_M1_0_6.mat("elec6").maxh(0.1)
geo.Add(regp_M1_0_6 , bcmod=[(regp_M1_0_6,'6')])
regp_M1_0_7  = planes * p_M1_0_7.mat("elec7").maxh(0.1)
geo.Add(regp_M1_0_7 , bcmod=[(regp_M1_0_7,'7')])
regp_M1_0_8  = planes * p_M1_0_8.mat("elec8").maxh(0.1)
geo.Add(regp_M1_0_8 , bcmod=[(regp_M1_0_8,'8')])
regp_M1_0_9  = planes * p_M1_0_9.mat("elec9").maxh(0.1)
geo.Add(regp_M1_0_9 , bcmod=[(regp_M1_0_9,'9')])
regp_M1_0_10  = planes * p_M1_0_10.mat("elec10").maxh(0.1)
geo.Add(regp_M1_0_10 , bcmod=[(regp_M1_0_10,'10')])
geo.PeriodicSurfaces(p3,p4)
geo.PeriodicSurfaces(p5,p6)
# list of dirichlet bc values: 1,2,3,4,5,6,7,8,9,10,
# 1 p_M1_0_1
# 2 p_M1_0_2
# 3 p_M1_0_3
# 4 p_M1_0_4
# 5 p_M1_0_5
# 6 p_M1_0_6
# 7 p_M1_0_7
# 8 p_M1_0_8
# 9 p_M1_0_9
# 10 p_M1_0_10

from ngsolve import *
mesh = Mesh(geo.GenerateMesh())
t0 = time.perf_counter()
print(mesh.GetBoundaries())
print(mesh.GetMaterials())
# mesh done, now calculating cap mat
t0 = time.perf_counter()
#mesh = Mesh("ngmesh.vol")
fout = open("capmat.txt", "w")
# H1-conforming finite element space
fes = Periodic(H1(mesh, order=3, dirichlet="1|2|3|4|5|6|7|8|9|10|"))
# define trial- and test-functions
u = fes.TrialFunction()
v = fes.TestFunction()
# the right hand side
f = LinearForm(fes)
f += 0 * v * dx
# the bilinear-form
a = BilinearForm(fes, symmetric=True)
a += grad(u)*grad(v)*dx
#c = Preconditioner(a,"multigrid")
c = Preconditioner(a,"local")
#c = Preconditioner(a,"direct")
a.Assemble()
f.Assemble()
t1 = time.perf_counter()
print(f"Assemble {t1 - t0:0.4f} seconds")
# the solution field
gfu = GridFunction(fes)
ntot = 10
#ntot = 1
for elec in range(0,ntot):
     print("elec=", elec)
     gfu.Set(1.0, definedon=mesh.Boundaries(str(elec+1)))
#     gfu.Set(1.0, definedon=mesh.Materials(str(elec+1)))
     BVP(bf=a, gf=gfu, lf=f, pre=c, maxsteps=50).Do()
     Draw(gfu, mesh, "u")
     t2 = time.perf_counter()
     print(f"BVP {t2 - t1:0.4f} seconds")
     print("starting gfE.Set( -grad(gfu))")
     fes_flux = HDiv(mesh, order=3)
     gfE = GridFunction(fes_flux)
     gfE.Set( -grad(gfu))
     Draw(gfE, mesh, "E")
     func_domain2 = -CoefficientFunction (specialcf.normal(3))
     bfv2 = BoundaryFromVolumeCF(func_domain2)
     Draw (bfv2, mesh, "normal-vec")
     fout.write(f"{elec} ")
     sum=0
     for i in range(0, ntot):
         charge = (Integrate(sqrt((gfE*bfv2)**2), mesh, definedon=mesh.Boundaries(str(i+1))))
         if elec != i :
             charge = -charge
         print ("Integral = ", charge)
         sum += charge
         fout.write(f"{charge:0.4f} ")
     fout.write(f"  sum={sum:0.4f}\n")
     print("sum=",sum)
fout.close()
t3 = time.perf_counter()
print(f"total {t3 - t0:0.4f} seconds")

